// ==============================================================
// RTL generated by Vitis HLS - High-Level Synthesis from C, C++ and OpenCL v2021.2 (64-bit)
// Version: 2021.2
// Copyright (C) Copyright 1986-2021 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

module PreRun_Pipeline_VITIS_LOOP_590_1 (
        ap_clk,
        ap_rst,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        uart_shm_Addr_A,
        uart_shm_EN_A,
        uart_shm_WEN_A,
        uart_shm_Din_A,
        uart_shm_Dout_A
);

parameter    ap_ST_fsm_state1 = 4'd1;
parameter    ap_ST_fsm_state2 = 4'd2;
parameter    ap_ST_fsm_state3 = 4'd4;
parameter    ap_ST_fsm_state4 = 4'd8;

input   ap_clk;
input   ap_rst;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
output  [31:0] uart_shm_Addr_A;
output   uart_shm_EN_A;
output  [3:0] uart_shm_WEN_A;
output  [31:0] uart_shm_Din_A;
input  [31:0] uart_shm_Dout_A;

reg ap_done;
reg ap_idle;
reg ap_ready;
reg uart_shm_EN_A;
reg[3:0] uart_shm_WEN_A;

(* fsm_encoding = "none" *) reg   [3:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
wire   [31:0] zext_ln590_fu_72_p1;
wire    ap_CS_fsm_state2;
wire   [0:0] icmp_ln590_fu_53_p2;
reg   [11:0] i_2_fu_30;
wire   [11:0] add_ln590_fu_48_p2;
wire   [10:0] trunc_ln590_fu_68_p1;
wire    ap_CS_fsm_state4;
reg   [3:0] ap_NS_fsm;
reg    ap_ST_fsm_state1_blk;
wire    ap_ST_fsm_state2_blk;
wire    ap_ST_fsm_state3_blk;
wire    ap_ST_fsm_state4_blk;
wire    ap_ce_reg;

// power-on initialization
initial begin
#0 ap_CS_fsm = 4'd1;
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if (((ap_start == 1'b1) & (1'b1 == ap_CS_fsm_state1))) begin
        i_2_fu_30 <= 12'd0;
    end else if (((icmp_ln590_fu_53_p2 == 1'd0) & (1'b1 == ap_CS_fsm_state2))) begin
        i_2_fu_30 <= add_ln590_fu_48_p2;
    end
end

always @ (*) begin
    if ((ap_start == 1'b0)) begin
        ap_ST_fsm_state1_blk = 1'b1;
    end else begin
        ap_ST_fsm_state1_blk = 1'b0;
    end
end

assign ap_ST_fsm_state2_blk = 1'b0;

assign ap_ST_fsm_state3_blk = 1'b0;

assign ap_ST_fsm_state4_blk = 1'b0;

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state4) | ((ap_start == 1'b0) & (1'b1 == ap_CS_fsm_state1)))) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((ap_start == 1'b0) & (1'b1 == ap_CS_fsm_state1))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state4)) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state2)) begin
        uart_shm_EN_A = 1'b1;
    end else begin
        uart_shm_EN_A = 1'b0;
    end
end

always @ (*) begin
    if (((icmp_ln590_fu_53_p2 == 1'd0) & (1'b1 == ap_CS_fsm_state2))) begin
        uart_shm_WEN_A = 4'd15;
    end else begin
        uart_shm_WEN_A = 4'd0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((ap_start == 1'b1) & (1'b1 == ap_CS_fsm_state1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            if (((icmp_ln590_fu_53_p2 == 1'd0) & (1'b1 == ap_CS_fsm_state2))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state3;
            end
        end
        ap_ST_fsm_state3 : begin
            ap_NS_fsm = ap_ST_fsm_state4;
        end
        ap_ST_fsm_state4 : begin
            ap_NS_fsm = ap_ST_fsm_state1;
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign add_ln590_fu_48_p2 = (i_2_fu_30 + 12'd1);

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state2 = ap_CS_fsm[32'd1];

assign ap_CS_fsm_state4 = ap_CS_fsm[32'd3];

assign icmp_ln590_fu_53_p2 = ((i_2_fu_30 == 12'd2048) ? 1'b1 : 1'b0);

assign trunc_ln590_fu_68_p1 = i_2_fu_30[10:0];

assign uart_shm_Addr_A = zext_ln590_fu_72_p1 << 32'd2;

assign uart_shm_Din_A = 32'd0;

assign zext_ln590_fu_72_p1 = trunc_ln590_fu_68_p1;

endmodule //PreRun_Pipeline_VITIS_LOOP_590_1
