/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
`include "sim_common_definitions.vh"

module sim_pwm_generator
(
input clk,
input [31:0] val_in,
output pwm_out
);

/*delta-sigma pwm logic
reg [`SIM_AOUT_PWM_BITS:0] pwm_accumulator;
initial pwm_accumulator <= 0;
always @(posedge clk) pwm_accumulator <= pwm_accumulator[`SIM_AOUT_PWM_BITS-1:0] + val_in;
assign pwm_out = pwm_accumulator[`SIM_AOUT_PWM_BITS];
*/

/*up-down counter pwm logic
reg [`SIM_AOUT_PWM_BITS-1:0] cnt;
reg cnt_dir;  // 0 to count up, 1 to count down
initial begin
    cnt <= 0;
    cnt_dir = 0;
end
wire [`SIM_AOUT_PWM_BITS-1:0] cnt_next = cnt_dir ? cnt-1'b1 : cnt+1'b1;
wire cnt_end = cnt_dir ? cnt==0 : cnt==`SIM_AOUT_PWM_MAX_VAL;

always @(posedge clk) cnt <= cnt_end ? val_in : cnt_next;
always @(posedge clk) cnt_dir <= cnt_dir ^ cnt_end;
assign pwm_out = cnt_dir;
*/

/*ramp counter*/
reg [`SIM_AOUT_PWM_BITS-1:0] cnt;
initial begin
    cnt <= 0;
end
always @(posedge clk) cnt <= cnt + 1'b1;
assign pwm_out = (val_in > cnt);

endmodule
