/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef FPGA_H
#define FPGA_H

#include "fpga_common_defs.h"

//#define UNDER_TESTING
#define DELAY_WAIT_CLKS 8//minimum 2. recommended is 8.

#ifndef SHM0_DATA_SIZE
#define SHM0_DATA_SIZE 2046
#endif
#define SHM0_CTRL_SIZE 2
#define SHM0_BUF_SIZE (SHM0_DATA_SIZE+SHM0_CTRL_SIZE)
#define SHM0_CTRL_RSIZE_IDX (SHM0_BUF_SIZE-1)
#define SHM0_CTRL_WSIZE_IDX (SHM0_BUF_SIZE-2)

#ifndef SHM1_DATA_SIZE
#define SHM1_DATA_SIZE 2046
#endif
#define SHM1_CTRL_SIZE 2
#define SHM1_BUF_SIZE (SHM1_DATA_SIZE+SHM1_CTRL_SIZE)
#define SHM1_CTRL_RSIZE_IDX (SHM1_BUF_SIZE-1)
#define SHM1_CTRL_WSIZE_IDX (SHM1_BUF_SIZE-2)

#ifndef SHM2_DATA_SIZE
#define SHM2_DATA_SIZE 2046
#endif
#define SHM2_CTRL_SIZE 2
#define SHM2_BUF_SIZE (SHM2_DATA_SIZE+SHM2_CTRL_SIZE)
#define SHM2_CTRL_RSIZE_IDX (SHM2_BUF_SIZE-1)
#define SHM2_CTRL_WSIZE_IDX (SHM2_BUF_SIZE-2)

#ifndef SHM3_DATA_SIZE
#define SHM3_DATA_SIZE 2046
#endif
#define SHM3_CTRL_SIZE 2
#define SHM3_BUF_SIZE (SHM3_DATA_SIZE+SHM3_CTRL_SIZE)
#define SHM3_CTRL_RSIZE_IDX (SHM3_BUF_SIZE-1)
#define SHM3_CTRL_WSIZE_IDX (SHM3_BUF_SIZE-2)

#ifdef UNDER_TESTING//enable only one
//#define _BUILD_BRD_ARTY_XC7A100T
//#define _BUILD_BRD_ARTY_XC7A35T
//#define _BUILD_BRD_ARTY_XC7S50T
#define _BUILD_BRD_ARTY_XC7Z020

//#define FPGA_ENABLE_PCIE_COMM
//#define FPGA_ENABLE_ETH_COMM
#if defined _BUILD_BRD_ARTY_XC7A35T || defined _BUILD_BRD_ARTY_XC7S50T || _BUILD_BRD_ARTY_XC7A100T
#define FPGA_ENABLE_UART_COMM
#endif
#if defined _BUILD_BRD_ARTY_XC7Z020
#define FPGA_ENABLE_SHM_0
#define FPGA_SHM0_AXI_LITE_SLAVE
#endif
#endif//UNDER_TESTING

////////////////////////////////////////////////////////////////////////////////////////////////
#define N_AIN_PORTS             16
#define N_AOUT_PORTS            16

#define HIGH                    1
#define LOW                     0
#define INPUT                   0
#define OUTPUT                  1
#define INPUT_PULLUP            2
#define INPUT_PULLDOWN          3
#define OUTPUT_OPENDRAIN        4
#define INPUT_DISABLE           5
#define LSBFIRST                0
#define MSBFIRST                1
#define CHANGE                  4
#define FALLING                 2
#define RISING                  3
#define GPIO_MAX_EXTI_SIZE      8

#ifdef __cplusplus
extern "C"{
#endif
////////////////////////////////////////////////////////////////user functions/////////////////////////////////////////////////////////////////////////////
void fpga_main(_UINT64 rt_clk_ticks
#ifdef FPGA_ENABLE_PCIE_COMM
        , volatile _UINT64 pcie_shm[PCIE_SHM_SIZE]
#endif
#ifdef FPGA_ENABLE_ETH_COMM
        , volatile _UINT32 eth_shm[ETH_SHM_SIZE]
#endif
#ifdef FPGA_ENABLE_UART_COMM
        , volatile _UINT32 uart_shm[UART_SHM_SIZE]
#endif
#ifdef FPGA_ENABLE_SHM_0
        , volatile _UINT32 shm0[SHM0_BUF_SIZE]
#endif
#ifdef FPGA_ENABLE_SHM_1
        , volatile _UINT32 shm1[SHM1_BUF_SIZE]
#endif
#ifdef FPGA_ENABLE_SHM_2
        , volatile _UINT32 shm2[SHM2_BUF_SIZE]
#endif
#ifdef FPGA_ENABLE_SHM_3
        , volatile _UINT32 shm3[SHM3_BUF_SIZE]
#endif
        , AIN_DTYPE ai_CH_A1, AIN_DTYPE ai_CH_A0, AIN_DTYPE ai_CH_A2, _BIT di_SW0, _BIT di_BTN2, _BIT di_BTN1, _BIT di_BTN0, _BIT di_SW1, _BIT di_SW2, AOUT_DTYPE &ao_LED1_B, AOUT_DTYPE &ao_LED1_G, AOUT_DTYPE &ao_LED1_R, AOUT_DTYPE &ao_LED0_B, AOUT_DTYPE &ao_LED0_G, AOUT_DTYPE &ao_LED0_R, _BIT &do_LED4
        );
_UINT64 millis();
_UINT64 micros();
void delay(_UINT64);
void delayMicroseconds(_UINT64);
void fpga_wait();
//
#ifdef __cplusplus
}
#endif
#endif //FPGA_H
