/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef FPGA_COMMON_DEFS_H
#define FPGA_COMMON_DEFS_H

#include "sim_generic_type_defs.h"
//#include "systemc.h"

typedef _UINT16         AIN_DTYPE;
typedef _UINT32         AOUT_DTYPE;
struct AXICOMM_DEV_CONTEXT
{
    bool read_dev_rst;
    _UINT32 read_size;
    _UINT32 read_idx;//used in parent
    //
    bool write_dev_rst;
    _UINT32 write_size;
    bool write_idle;
};
///////////////////shared definitions between fpga_main and fpga_devcomm//////////////////////////////////////
#define PCIE_SHM_SIZE			4096
#define PCIE_CTRL_SIZE			2
#define PCIE_CTRL_RSIZE_IDX		(PCIE_SHM_SIZE-1)
#define PCIE_CTRL_WSIZE_IDX		(PCIE_SHM_SIZE-2)
//
#define ETH_SHM_SIZE			4096
#define ETH_CTRL_SIZE			2
#define ETH_CTRL_RSIZE_IDX		(ETH_SHM_SIZE-1)
#define ETH_CTRL_WSIZE_IDX		(ETH_SHM_SIZE-2)
//
#define UART_SHM_SIZE			2048
#define UART_CTRL_SIZE			2
#define UART_CTRL_RSIZE_IDX		(UART_SHM_SIZE-1)
#define UART_CTRL_WSIZE_IDX		(UART_SHM_SIZE-2)
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))
#define constrain(amt,low,high) ((amt)<(low)?(low):((amt)>(high)?(high):(amt)))
#define radians(deg) ((deg)*DEG_TO_RAD)
#define degrees(rad) ((rad)*RAD_TO_DEG)
#define sq(x) ((x)*(x))

#define lowByte(w) ((_BYTE) ((w) & 0xff))
#define highByte(w) ((_BYTE) ((w) >> 8))

#define bitRead(value, bit) (((value) >> (bit)) & 1)
#define bitSet(value, bit) ((value) |= (1 << (bit)))
#define bitClear(value, bit) ((value) &= ~(1 << (bit)))
#define bitWrite(value, bit, bitvalue) ((bitvalue==0) ? bitClear(value, bit) : bitSet(value, bit))

#endif//FPGA_COMMON_DEFS_H
