/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
`include "sim_common_definitions.vh"
`include "sim_pwm_gen.v"

module sim_da_out_ports
(
input clk,
input[63:0] dout_data,
input aout_ce,
input [3:0] aout_waddr,
input [31:0] aout_data,
output LD0_R, LD0_G, LD0_B, LD1_R, LD1_G, LD1_B, LD2, LD3, LD4, LD5
);

//digital out
assign LD2 = dout_data[0];
assign LD3 = dout_data[1];
assign LD4 = dout_data[2];
assign LD5 = dout_data[3];

//analog out
reg [31:0] aout_buffer[`MAX_AOUT_PORTS-1:0];
reg [4:0] i;
initial begin
    for(i=0; i<`MAX_AOUT_PORTS; i=i+1) aout_buffer[i] <= 0;
end

always @ (posedge clk)
begin
    if(aout_ce) begin
        aout_buffer[aout_waddr] <= aout_data;
    end
end


sim_pwm_generator pwm_gen_0(clk, aout_buffer[0], LD0_R);
sim_pwm_generator pwm_gen_1(clk, aout_buffer[1], LD0_G);
sim_pwm_generator pwm_gen_2(clk, aout_buffer[2], LD0_B);
        
endmodule
