/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef SIM_DEBUG_H
#define SIM_DEBUG_H

#include <stdio.h>
#include "sim_compiler_definitions.h"

#ifdef __cplusplus
extern "C"{
#endif

void sim_debug_print(const char *data, int size);

#ifdef SIM_DEBUG_LOCAL
#define CASP_LED(x) do {} while(0);
#define CASP_LED0(x) CASP_LED(x)
#define CASP_LED1(x) do {} while(0);
#define CASP_LED2(x) do {} while(0);
#endif

#if !defined(SIM_DEBUG_LOCAL) && !defined(CASP_LED)
#define CASP_LED(x) do {} while(0);
#define CASP_LED0(x) CASP_LED(x)
#define CASP_LED1(x) do {} while(0);
#define CASP_LED2(x) do {} while(0);
#endif

#ifdef SIM_DEBUG_REMOTE
#define CASP_PRINT(x) do { \
    char buf[250];	\
    int size = snprintf(buf, 249, x); \
    sim_debug_print(buf, size); \
}while(0);
#define CASP_PRINT_ARG(format, args...) do { \
    char buf[250];	\
    int size = snprintf(buf, 249, format, args); \
    sim_debug_print(buf, size); \
} while(0);
#endif//SIM_DEBUG_REMOTE

#if !defined(SIM_DEBUG_REMOTE) && !defined(CASP_PRINT)
#define CASP_PRINT(x) do {} while(0);
#define CASP_PRINT_ARG(format, args...) do {} while(0);
#endif

#ifdef __cplusplus
}
#endif

#endif//SIM_DEBUG_H
