/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#include "xsoc.h"

void SystemInit(void)
{
    if(SIM_EXEC_CORE > -1)
    {
        //disable cache on OCM. L2 cache need not be disabled for Core2 explicitly as DDR of non-cacheable address from 0x10000 is used as per linker file.
        Xil_SetTlbAttributes(0xfffffff0, 0x14de2);//S=b1 TEX=b100 AP=b11, Domain=b1111, C=b0, B=b0
    }
    //init second core
    if(SIM_EXEC_CORE == 0)//for core0 in dual core mode
    {
        Xil_Out32(0xfffffff0, 0x10000000);//core1 address shall be matched with core1 linker file.
        //Xil_DCacheFlush();
        dmb(); //ensure cache coherence
        sev();
    }
}

void initVariant1()
{
    //set timer to count micros seconds
//    if(SIM_EXEC_CORE == 1)
//    {
//        while(1)
//        {
//            sleep(1);
//            Xil_Out32(0x81200008, 0x00);
//            sleep(1);
//            Xil_Out32(0x81200008, 0xff);
//        }
//    }
    //Xil_DCacheDisable();
    //Xil_ICacheDisable();
    //xil_printf
}

void initVariant2()
{

}

unsigned long long millis()
{
    //page 112 of 346 in UG643 (2018.2) June 6, 2018
    XTime time;
    XTime_GetTime(&time);
    return (unsigned long long)(time/(COUNTS_PER_SECOND/1000));
}

unsigned long long micros()
{
    XTime time;
    XTime_GetTime(&time);
    return (unsigned long long)(time/(COUNTS_PER_SECOND/1000000));
}

void delay(unsigned long delay)
{
    //code copied from sleep_A9 function
    XTime tEnd, tCur;
    XTime_GetTime(&tCur);
    tEnd  = tCur + (((XTime)delay) * (COUNTS_PER_SECOND/1000));
    do
    {
        XTime_GetTime(&tCur);
    }while (tCur < tEnd);
}

void delayMicroseconds(unsigned long delay)
{
    //code copied from sleep_A9 function
    XTime tEnd, tCur;
    XTime_GetTime(&tCur);
    tEnd  = tCur + (((XTime)delay) * (COUNTS_PER_SECOND/1000000));
    do
    {
        XTime_GetTime(&tCur);
    }while (tCur < tEnd);
}


